diff --git a/web/pgadmin/browser/server_groups/servers/databases/languages/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/languages/__init__.py
index 07c04e9..d00f0dc 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/languages/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/languages/__init__.py
@@ -27,6 +27,41 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will check the
+    database connection before running the view. It also attaches
+    manager, conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.driver = get_driver(PG_DEFAULT_DRIVER)
+        self.manager = self.driver.connection_manager(kwargs['sid'])
+        self.conn = self.manager.connection(did=kwargs['did'])
+
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        ver = self.manager.version
+        # we will set template path for sql scripts
+        if ver >= 90300:
+            self.template_path = 'languages/sql/9.3_plus'
+        else:
+            self.template_path = 'languages/sql/9.1_plus'
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class LanguageModule(CollectionNodeModule):
     """
     class LanguageModule(CollectionNodeModule)
@@ -65,6 +100,7 @@ class LanguageModule(CollectionNodeModule):
 
         super(LanguageModule, self).__init__(*args, **kwargs)
 
+    @check_precondition
     def get_nodes(self, gid, sid, did):
         """
         Method is used to generate the browser collection node
@@ -74,7 +110,17 @@ class LanguageModule(CollectionNodeModule):
             sid: Server ID
             did: Database Id
         """
-        yield self.generate_browser_collection_node(did)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path, 'properties.sql']))
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(did, collection_count)
 
     @property
     def node_inode(self):
@@ -204,40 +250,6 @@ class LanguageView(PGChildNodeView):
             200, {'Content-Type': 'application/x-javascript'}
         )
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will check the
-        database connection before running the view. It also attaches
-        manager, conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.driver = get_driver(PG_DEFAULT_DRIVER)
-            self.manager = self.driver.connection_manager(kwargs['sid'])
-            self.conn = self.manager.connection(did=kwargs['did'])
-
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            ver = self.manager.version
-            # we will set template path for sql scripts
-            if ver >= 90300:
-                self.template_path = 'languages/sql/9.3_plus'
-            else:
-                self.template_path = 'languages/sql/9.1_plus'
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/__init__.py
index 4671897..ec7414b 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/__init__.py
@@ -44,6 +44,47 @@ from config import PG_DEFAULT_DRIVER
 """
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to instance of the method.
+
+    Assumptions:
+        This function will always be used as decorator of a class method.
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(
+            kwargs['sid']
+        )
+        self.conn = self.manager.connection(did=kwargs['did'])
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext("Connection to the server has been lost!")
+            )
+
+        # Set template path for sql scripts
+        if hasattr(self, 'NODE_TYPE'):
+            initial_path = self.NODE_TYPE
+        else:
+            initial_path = self.template_initial
+
+        self.template_path = initial_path + '/' + (
+            SchemaView.ppas_template_path(self.manager.version)
+            if self.manager.server_type == 'ppas' else
+            SchemaView.pg_template_path(self.manager.version)
+        )
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class SchemaModule(CollectionNodeModule):
     """
      class SchemaModule(CollectionNodeModule)
@@ -81,11 +122,26 @@ class SchemaModule(CollectionNodeModule):
 
         super(SchemaModule, self).__init__(*args, **kwargs)
 
+    @check_precondition
     def get_nodes(self, gid, sid, did):
         """
         Generate the collection node
         """
-        yield self.generate_browser_collection_node(did)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template(
+            "/".join([self.template_path, 'sql/nodes.sql']),
+            show_sysobj=self.show_system_objects,
+            _=gettext
+        )
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(did, collection_count)
 
     @property
     def script_load(self):
@@ -111,42 +167,6 @@ schema_blueprint = SchemaModule(__name__)
 catalog_blueprint = CatalogModule(__name__)
 
 
-def check_precondition(f):
-    """
-    This function will behave as a decorator which will checks
-    database connection before running view, it will also attaches
-    manager,conn & template_path properties to instance of the method.
-
-    Assumptions:
-        This function will always be used as decorator of a class method.
-    """
-
-    @wraps(f)
-    def wrap(*args, **kwargs):
-        # Here args[0] will hold self & kwargs will hold gid,sid,did
-        self = args[0]
-        self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(
-            kwargs['sid']
-        )
-        self.conn = self.manager.connection(did=kwargs['did'])
-        # If DB not connected then return error to browser
-        if not self.conn.connected():
-            return precondition_required(
-                gettext("Connection to the server has been lost!")
-            )
-
-        # Set template path for sql scripts
-        self.template_path = self.template_initial + '/' + (
-            self.ppas_template_path(self.manager.version)
-            if self.manager.server_type == 'ppas' else
-            self.pg_template_path(self.manager.version)
-        )
-
-        return f(*args, **kwargs)
-
-    return wrap
-
-
 class SchemaView(PGChildNodeView):
     """
     This class is responsible for generating routes for schema node.
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/catalog_objects/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/catalog_objects/__init__.py
index e55afdf..77e18bd 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/catalog_objects/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/catalog_objects/__init__.py
@@ -25,6 +25,38 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(
+            kwargs['sid']
+        )
+        self.conn = self.manager.connection(did=kwargs['did'])
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        self.template_path = 'catalog_object/sql/{0}/9.1_plus'.format(
+            'ppas' if self.manager.server_type == 'ppas' else 'pg'
+        )
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class CatalogObjectModule(SchemaChildModule):
     """
      class CatalogObjectModule(SchemaChildModule)
@@ -65,11 +97,23 @@ class CatalogObjectModule(SchemaChildModule):
         self.min_ver = None
         self.max_ver = None
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, scid):
         """
         Generate the collection node
         """
-        yield self.generate_browser_collection_node(scid)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path, 'nodes.sql']),
+                                   scid=scid)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(scid, collection_count)
 
     @property
     def script_load(self):
@@ -131,37 +175,6 @@ class CatalogObjectView(PGChildNodeView):
         'module.js': [{}, {}, {'get': 'module_js'}]
     })
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(
-                kwargs['sid']
-            )
-            self.conn = self.manager.connection(did=kwargs['did'])
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            self.template_path = 'catalog_object/sql/{0}/9.1_plus'.format(
-                'ppas' if self.manager.server_type == 'ppas' else 'pg'
-            )
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did, scid):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/catalog_objects/columns/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/catalog_objects/columns/__init__.py
index b0e784f..ad22506 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/catalog_objects/columns/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/catalog_objects/columns/__init__.py
@@ -25,6 +25,36 @@ from pgadmin.utils.preferences import Preferences
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(
+            kwargs['sid']
+        )
+        self.conn = self.manager.connection(did=kwargs['did'])
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        self.template_path = 'catalog_object_column/sql/9.1_plus'
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class CatalogObjectColumnsModule(CollectionNodeModule):
     """
      class ColumnModule(CollectionNodeModule)
@@ -62,11 +92,23 @@ class CatalogObjectColumnsModule(CollectionNodeModule):
         self.min_ver = None
         self.max_ver = None
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, scid, coid):
         """
         Generate the collection node
         """
-        yield self.generate_browser_collection_node(coid)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path,'nodes.sql']),
+                                   coid=coid)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(coid, collection_count)
 
     @property
     def script_load(self):
@@ -151,35 +193,6 @@ class CatalogObjectColumnsView(PGChildNodeView):
         'module.js': [{}, {}, {'get': 'module_js'}]
     })
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(
-                kwargs['sid']
-            )
-            self.conn = self.manager.connection(did=kwargs['did'])
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            self.template_path = 'catalog_object_column/sql/9.1_plus'
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did, scid, coid):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/collations/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/collations/__init__.py
index c4e7bc3..034f2ff 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/collations/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/collations/__init__.py
@@ -26,6 +26,36 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(
+            kwargs['sid']
+        )
+        self.conn = self.manager.connection(did=kwargs['did'])
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        # we will set template path for sql scripts
+        self.template_path = 'collation/sql/9.1_plus'
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class CollationModule(SchemaChildModule):
     """
      class CollationModule(CollectionNodeModule)
@@ -64,11 +94,23 @@ class CollationModule(SchemaChildModule):
         self.min_ver = 90100
         self.max_ver = None
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, scid):
         """
         Generate the collection node
         """
-        yield self.generate_browser_collection_node(scid)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path, 'nodes.sql']),
+                                   scid=scid)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(scid, collection_count)
 
     @property
     def script_load(self):
@@ -170,35 +212,6 @@ class CollationView(PGChildNodeView):
                            {'get': 'get_collation'}]
     })
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(
-                kwargs['sid']
-            )
-            self.conn = self.manager.connection(did=kwargs['did'])
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            # we will set template path for sql scripts
-            self.template_path = 'collation/sql/9.1_plus'
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did, scid):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/__init__.py
index c94525a..4ea85a5 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/__init__.py
@@ -28,6 +28,40 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    Works as a decorator.
+    Checks database connection status.
+    Attach connection object and template path.
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        self = args[0]
+        driver = get_driver(PG_DEFAULT_DRIVER)
+        self.manager = driver.connection_manager(kwargs['sid'])
+        # Get database connection
+        self.conn = self.manager.connection(did=kwargs['did'])
+        self.qtIdent = driver.qtIdent
+
+        if not self.conn.connected():
+            return precondition_required(
+                gettext("Connection to the server has been lost!")
+            )
+
+        ver = self.manager.version
+        server_type = self.manager.server_type
+
+        # we will set template path for sql scripts
+        if ver >= 90200:
+            self.template_path = 'domains/sql/9.2_plus'
+        elif ver >= 90100:
+            self.template_path = 'domains/sql/9.1_plus'
+
+        return f(*args, **kwargs)
+
+    return wrap
+
 class DomainModule(SchemaChildModule):
     """
     class DomainModule(SchemaChildModule):
@@ -55,11 +89,23 @@ class DomainModule(SchemaChildModule):
         self.min_ver = None
         self.max_ver = None
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, scid):
         """
         Generate the domain collection node.
         """
-        yield self.generate_browser_collection_node(scid)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path, 'node.sql']),
+                                   scid=scid)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(scid, collection_count)
 
     @property
     def script_load(self):
@@ -247,40 +293,6 @@ class DomainView(PGChildNodeView, DataTypeReader):
             200, {'Content-Type': 'application/x-javascript'}
         )
 
-    def check_precondition(f):
-        """
-        Works as a decorator.
-        Checks database connection status.
-        Attach connection object and template path.
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            self = args[0]
-            driver = get_driver(PG_DEFAULT_DRIVER)
-            self.manager = driver.connection_manager(kwargs['sid'])
-            # Get database connection
-            self.conn = self.manager.connection(did=kwargs['did'])
-            self.qtIdent = driver.qtIdent
-
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext("Connection to the server has been lost!")
-                )
-
-            ver = self.manager.version
-            server_type = self.manager.server_type
-
-            # we will set template path for sql scripts
-            if ver >= 90200:
-                self.template_path = 'domains/sql/9.2_plus'
-            elif ver >= 90100:
-                self.template_path = 'domains/sql/9.1_plus'
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did, scid):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/domain_constraints/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/domain_constraints/__init__.py
index 8eef4d1..5abb2bb 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/domain_constraints/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/domain_constraints/__init__.py
@@ -26,6 +26,40 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    Works as a decorator.
+    Checks database connection status.
+    Attach connection object and template path.
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        self = args[0]
+        driver = get_driver(PG_DEFAULT_DRIVER)
+        self.manager = driver.connection_manager(kwargs['sid'])
+        self.conn = self.manager.connection(did=kwargs['did'])
+        self.qtIdent = driver.qtIdent
+
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext("Connection to the server has been lost!")
+            )
+
+        ver = self.manager.version
+
+        # we will set template path for sql scripts
+        if ver >= 90200:
+            self.template_path = 'domain_constraints/sql/9.2_plus'
+        elif ver >= 90100:
+            self.template_path = 'domain_constraints/sql/9.1_plus'
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class DomainConstraintModule(CollectionNodeModule):
     """
     class DomainConstraintModule(CollectionNodeModule):
@@ -55,11 +89,23 @@ class DomainConstraintModule(CollectionNodeModule):
         self.min_ver = None
         self.max_ver = None
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, scid, doid):
         """
         Generate the Domain Constraint collection node.
         """
-        yield self.generate_browser_collection_node(doid)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path, 'properties.sql']),
+                                   doid=doid)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(doid, collection_count)
 
     @property
     def node_inode(self):
@@ -241,39 +287,6 @@ class DomainConstraintView(PGChildNodeView):
             200, {'Content-Type': 'application/x-javascript'}
         )
 
-    def check_precondition(f):
-        """
-        Works as a decorator.
-        Checks database connection status.
-        Attach connection object and template path.
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            self = args[0]
-            driver = get_driver(PG_DEFAULT_DRIVER)
-            self.manager = driver.connection_manager(kwargs['sid'])
-            self.conn = self.manager.connection(did=kwargs['did'])
-            self.qtIdent = driver.qtIdent
-
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext("Connection to the server has been lost!")
-                )
-
-            ver = self.manager.version
-
-            # we will set template path for sql scripts
-            if ver >= 90200:
-                self.template_path = 'domain_constraints/sql/9.2_plus'
-            elif ver >= 90100:
-                self.template_path = 'domain_constraints/sql/9.1_plus'
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did, scid, doid):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/foreign_tables/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/foreign_tables/__init__.py
index 98182fc..4325887 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/foreign_tables/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/foreign_tables/__init__.py
@@ -33,6 +33,49 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    Works as a decorator.
+    Checks the database connection status.
+    Attaches the connection object and template path to the class object.
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        self = args[0]
+        driver = get_driver(PG_DEFAULT_DRIVER)
+        self.manager = driver.connection_manager(kwargs['sid'])
+
+        # Get database connection
+        self.conn = self.manager.connection(did=kwargs['did'])
+
+        self.qtIdent = driver.qtIdent
+
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        ver = self.manager.version
+        server_type = self.manager.server_type
+
+        # Set template path for sql scripts depending
+        # on the server version.
+
+        if ver >= 90500:
+            self.template_path = 'foreign_tables/sql/9.5_plus'
+        elif ver >= 90200:
+            self.template_path = 'foreign_tables/sql/9.2_plus'
+        else:
+            self.template_path = 'foreign_tables/sql/9.1_plus'
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class ForeignTableModule(SchemaChildModule):
     """
     class ForeignTableModule(CollectionNodeModule):
@@ -62,11 +105,23 @@ class ForeignTableModule(SchemaChildModule):
         self.min_ver = None
         self.max_ver = None
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, scid):
         """
         Generate the Foreign Table collection node.
         """
-        yield self.generate_browser_collection_node(scid)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path, 'node.sql']),
+                                   scid=scid)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(scid, collection_count)
 
     @property
     def node_inode(self):
@@ -323,48 +378,6 @@ class ForeignTableView(PGChildNodeView, DataTypeReader):
             200, {'Content-Type': 'application/x-javascript'}
         )
 
-    def check_precondition(f):
-        """
-        Works as a decorator.
-        Checks the database connection status.
-        Attaches the connection object and template path to the class object.
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            self = args[0]
-            driver = get_driver(PG_DEFAULT_DRIVER)
-            self.manager = driver.connection_manager(kwargs['sid'])
-
-            # Get database connection
-            self.conn = self.manager.connection(did=kwargs['did'])
-
-            self.qtIdent = driver.qtIdent
-
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            ver = self.manager.version
-            server_type = self.manager.server_type
-
-            # Set template path for sql scripts depending
-            # on the server version.
-
-            if ver >= 90500:
-                self.template_path = 'foreign_tables/sql/9.5_plus'
-            elif ver >= 90200:
-                self.template_path = 'foreign_tables/sql/9.2_plus'
-            else:
-                self.template_path = 'foreign_tables/sql/9.1_plus'
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did, scid):
         """
